﻿Imports System.Collections.Generic
Imports System.Linq
Imports YMLib

Public Class frmMain_USB_REL_4
    Private WithEvents YMcom As DeviceServer

    Dim SendeByte1 As Byte
    Private _closing As Boolean

    Private Sub TestForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        YMcom = New DeviceServer()

        YMcom.ReadAllDevicesInterval = 1
        YMcom.ReadAllDevicesContinuously = True

        YMcom.Start()

    End Sub

    Private Sub _server_OnChecked() Handles YMcom.OnChecked
        Debug.WriteLine("***Checked***")
    End Sub

    Private Sub _server_OnDeviceConnected(device As Device) Handles YMcom.OnDeviceConnected
        Debug.WriteLine("Device Connected: " & device.Id & " (Addresses: " & device.Adresse & ")")
    End Sub

    Private Sub _server_OnDeviceDisconnected(device As Device) Handles YMcom.OnDeviceDisconnected
        Debug.WriteLine("Device Disconnected: " & device.Id & " (Addresses: " & device.Adresse & ")")
    End Sub

    Private Sub _server_OnRead(device As Device, data As ReadData) Handles YMcom.OnRead
        Dim line As String = $"Device Read (Addresse {device.Adresse}): {data.RelaisCount1}"


        Invoke(Sub()
                   Dim index As Integer = ComboBox1.SelectedIndex
                   Dim text As String = ComboBox1.Text


                   If (index > -1 AndAlso Not String.IsNullOrEmpty(text)) Then

                       Dim selectedAdresse As Integer = Convert.ToInt32(text)

                       Debug.WriteLine("selected2: " & selectedAdresse)

                       If (selectedAdresse = device.Adresse) Then
                           _UpdateChechboxes(data)
                       End If
                   End If

               End Sub)

        Debug.WriteLine(line)


    End Sub

    Private Sub _server_OnDevicesChanged(conntected() As Device, disconnected() As Device, devices() As Device) Handles YMcom.OnDevicesChanged
        Debug.WriteLine("devices changed***")
        Dim adresses As Integer() = devices.Select(Function(d) d.Adresse).ToArray()
        Dim duplicates As List(Of String) = adresses.GroupBy(Function(s) s).Where(Function(g) g.Count() > 1).Select(Function(g) g.Key.ToString()).ToList()

        Invoke(Sub()
                   Dim selectedAdresse As Integer = -1

                   If ComboBox1.SelectedIndex > -1 Then
                       selectedAdresse = Convert.ToInt32(ComboBox1.SelectedValue)
                   End If
                   ComboBox1.Text = ""
                   ComboBox1.Items.Clear()
                   For Each adresse As Integer In adresses
                       ComboBox1.Items.Add(adresse.ToString())
                   Next

                   If selectedAdresse > -1 AndAlso devices.Any(Function(d As Device) d.Adresse = selectedAdresse) Then
                       ComboBox1.SelectedValue = selectedAdresse.ToString()
                   End If

                   If devices.Count > 0 Then
                       'Dim duplicates As List(Of String) = currentConnectedDevices.GroupBy(Function(s) s.Adresse).Where(Function(g) g.Count() > 1).Select(Function(g) g.Key.ToString()).ToList()
                       If duplicates.Count > 0 Then
                           warningLabel.Text = "Duplicated Addressen: " & String.Join(", ", duplicates) & vbCrLf & "Writing and Reading is only possible for unique addresses"
                       Else
                           warningLabel.Text = ""
                       End If

                   End If
               End Sub)

    End Sub

    Private Sub _UpdateChechboxes(readData As ReadData)
        SendeByte1 = readData.RelaisCount1


        For i As Integer = 0 To 3
            myCheckBoxen1(i).Checked = (readData.RelaisCount1 And 1 << i) > 0
        Next i


    End Sub


#Region "User Action"
    Private Sub ComboBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBox1.SelectedIndexChanged
        If ComboBox1.SelectedIndex > -1 Then
            Dim device As Device = YMcom.GetDevice(Convert.ToInt32(ComboBox1.Text))
            If device IsNot Nothing Then
                txtProduktName.Text = device.Definition.ProductName
                txtSerialNr.Text = device.Definition.SerialNumber
            End If
        End If
    End Sub

    Private Sub btnAllON_Click(sender As Object, e As EventArgs) Handles btnAllON.Click

        SendeByte1 = 15

        SchaltZustandSenden()
    End Sub
    Private Sub btnAllOFF_Click(sender As Object, e As EventArgs) Handles btnAllOFF.Click

        SendeByte1 = 0

        SchaltZustandSenden()
    End Sub
    Private Sub Checkbox1_Click(sender As Object, e As EventArgs) Handles Checkbox1.Click, CheckBox2.Click, CheckBox3.Click, CheckBox4.Click
        Dim myCheckBoxRelKanal As CheckBox = DirectCast(sender, CheckBox)

        If myCheckBoxRelKanal.CheckState = 1 Then
            SendeByte1 += CInt(myCheckBoxRelKanal.Tag)
        Else
            SendeByte1 -= CInt(myCheckBoxRelKanal.Tag)
        End If
        SchaltZustandSenden()

    End Sub


    Private Sub AboutBox_Click(sender As Object, e As EventArgs) Handles AboutBox.Click
        YMcom.CALL_ABOUT_BOX()
    End Sub


#End Region


    Private Sub SchaltZustandSenden()
        Try
            YMcom.SEND_OUTPUT_STATUS_4(ComboBox1.Text, SendeByte1)
            WriteOutput.Text = "Succeeded"
        Catch ex As Exception
            WriteOutput.Text = "error or no device found by adresse" & "/" & ex.Message
        End Try
    End Sub

    Private Sub TestForm_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        Debug.WriteLine("closing")
        If YMcom IsNot Nothing Then
            YMcom.Stop()
        End If
        Debug.WriteLine("closing2")
    End Sub




End Class